/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     source code: ES6 (ECMAScript 6, ECMAScript 2015, JavaScript 6)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */
 

//  xxxxxxxxxxxxxxx    global variable declarations  xxxxxxxxxxxxxxxx


// These variables below can be directly modified by the user on the options form: 

var lc = 2;       // minimum visible shapes

var hc = 2;     // maximum visible shapes

var wc = 3;    // number of item within each level between lc..hc
  
var custom = false;   // use custom raster (true) or not (false). if custom == false default raster=10 is used in task 	

var raster = 10;       // screen (viewport) raster size	

var spatial = '1';   // circles spatial distribution ( "0" => None ; '1' =>Left-right '2'=> Up-down)
	
var wait = 30;   // number of basic time cycles BEFORE main stimulus (circles, dots) exposition. Units = number of basic timer resolution (clock=100ms). Time of displaying the fixing cross. Time between stimuli. 

var time = 1;     // stimulus exposition time in ms. Units = number of basic timer resolution (clock=100ms)

var delay = 10;   // delay between stimulus and user response. Units = number of basic timer resolution (clock=100ms)

var isCross = true;       // if isCross=true =>  The cross will appear in the center of the screen before the main stimulus 
  
var is_grid = false;   // draw canvas rectangle grid (true) or not (false)
 
var is_white = true;  // delay period background color. if true => white color; if false => black color
 
var demo = false;     // if (demo == true) => Solve the puzzle task 

var is_back = true;    // if (is_back==true) => user can undo last answer (go back to previous task/item).  

var prg_type = '1';   //  type of information in Progress Bar ("1" => Items, "0" => Nothing) 

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 

// Other global constants and variables:

const clock = 100;  // basic timer resolution in ms

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var step = -1;   // global timer counter

var is_task = false;    // task in progress or not for pageResize() event. is_task == true for all events between startTask() and theEnd() events

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var can_drag = false;      // user can drag and drop or not (only after main stimulus delay time period)

var item_cnt;       // the total number of items in the task

var item = 0;   // current item in task     

var is_storage= false; // local storage is enabled on user browser or not

//  global arrays declarations..
 
const outer = [ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 37, 38, 39, 40, 41, 42, 47, 48, 49, 50, 51, 52, 57, 58, 59, 60, 61, 62, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99 ];  						 

const inner4 = [ 43, 44, 45, 46 ];

const inner8 = [ 43, 44, 45, 46, 53, 54, 55, 56 ];

const inner16 = [ 33, 34, 35, 36, 43, 44, 45, 46, 53, 54, 55, 56, 63, 64, 65, 66 ];

const left = [ 0, 1, 2, 10, 11, 12, 20, 21, 22, 30, 31, 32, 40, 41, 42, 50, 51, 52, 60, 61, 62, 70, 71, 72, 80, 81, 82, 90, 91, 92 ];

const right = [ 7, 8, 9, 17, 18, 19, 27, 28, 29, 37, 38, 39, 47, 48, 49, 57, 58, 59, 67, 68, 69, 77, 78, 79, 87, 88, 89, 97, 98, 99 ]; 
//    up positions => 0..29   (first 3. rows)
//  down positions => 70..99  (last 3. rows)

var rects= [];   // array of objects that define different screen rectangles (cells)

var moves = []; // For each item: number of moves => see drop () event

/* circles positions before delay => correct array
   correct positions for each item if circle (dot) is displayed in this cell before delay = 1. 
   if circle (dot) is NOT displayed in this cell before delay = 0. */
var correct = [];   // item x cell. array range [0..item_cnt-1 x 0..raster*raster-1]. 

/* circles positions after delay => answer array
   for each item if circle (dot) is drag in this cell from user after delay = 1. 
	 if circle (dot) is NOT drag in this cell after delay = 0. */
var answer = [];   // item x cell. array range [0..item_cnt-1 x 0..raster*raster-1]


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


// application init [create/start Timer, check storage, show start panel..] 
function init() 
{    
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {appTimer()},clock);  
  
  is_storage= isStorage() && storageAvailable('localStorage');
  if (is_storage)  {
    document.getElementById('store_group').style.display= 'block';
		document.getElementById('no_storage').style.display= 'none';
  }		
		  
	setIns();
		
	showStart(); 
   
}


// application timer handler function
function appTimer()    
{  
   if (step<0) { 
		 return;  // nop, idle, just wait
   }
	 step++;    
   let canvas= document.getElementById('canvas'), ctx=canvas.getContext('2d');         
   if (step < wait-1)  
	 {   // time before stimulus (time between stimuli) 
      document.getElementById('next').style.display= 'none';  // disable next item while complete stimulus in not done
      if (step == 1 && !is_back) {
				canvas.style.cursor= 'none';
			}
			if (!isCross) { 
				return;  // idle, just wait main stimulus
			}  
      if (step == 1)  {				 
				document.getElementById('prior').style.display= (item > 0 && is_back) ? 'inline': 'none';  // set footer navigation prior button (left arrow) 		
				drawCross();   // always trigger this in first timer call
			}
			else if (step > wait- 20)
			{  // flick cross only in two second before main stimulus (change cross state visible <=> not visible)
				if (step % 2 != 0)  {    
					drawCross();     // draw Cross only if it is odd number  (1,3,5,..)  example if (before==6) = 3xflick            
				}
				else    {       // for even numbers  (2,4,6,..) => clear previous cross. 
					ctx.clearRect(0, 0, canvas.width, canvas.height);     // clear canvas => clear Cross in 2,4,6 step                         
				}  
			}      
   }
   else if (step == wait-1)   
	 {       // ALWAYS clear canvas before main stimulus display
     if (!isCross) { 
		   return; // idle, just wait main stimulus
		 }  
     ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear last cross if exists                 
   }    
   else if (step == wait) {
     document.getElementById('prior').style.display= 'none';
     drawStim(true);     // draw first part of stimulus (match)     
   }
   else if (step == wait+time) 
	 {
     ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear first part of stimulus  (stimulus before delay)          
     if (is_white && isCross)  {  
        drawCross();   // draw Cross => is_white must be true
     }     
     else if (!is_white)  {
				ctx.rect(0, 0, canvas.width, canvas.height);
				ctx.fillStyle = '#000';  // set black background color during delay period
				ctx.fill();
				document.body.style.backgroundColor= '#000';    				
		 }     
	 }
   else if (step >= wait+time+delay) 
	 {
     if (!is_white)  {
		   document.body.style.backgroundColor= '#fff';  // restore white color 
		 }
		 drawStim(false);     // after delay draw second part of stimulus (stimulus after delay)         
     step = -1;         // nop, idle, do none, Timer no operation     
   }
} 


// draws a cross before the main stimulus
function drawCross()  
{
  let canvas= document.getElementById('canvas');   
  let x= Math.round(canvas.width/2);
  let y= Math.round(canvas.height/2);
  let d = Math.floor(Math.min(x,y)/4);  // 1/8 min(width, height)  
  drawLine(x-d,y,x+d,y); // horizontal
  drawLine(x,y-d,x,y+d); // vertical 
}


// draw line on screen canvas
function drawLine(x1,y1,x2,y2)  
{  
	let ctx= document.getElementById('canvas').getContext('2d'); 
  ctx.beginPath();
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);  
  //ctx.lineWidth= 3;  //ctx.strokeStyle= '#000';  
  ctx.stroke(); 
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  
{
  if (typeof(Storage) !== 'undefined') {
     return true;                 
  } 
  else {
    return false;    
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) 
{
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// raised when page is resized. see html: <body onresize="pageResize()"
function pageResize()  
{ 
	if (is_task) { 
		setRects();		
	}
}	


// show start panel 
function showStart()  
{      
  document.getElementById('end').style.display= 'none';
  document.getElementById('result_wrapper').style.display= 'none';  
  document.getElementById('store_id').style.display= 'none';
	document.getElementById('table_grp').style.display= 'none';
	document.getElementById('start').style.display= 'block';	
}


// show form with application options
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  //document.body.style.backgroundColor= '#ffffff';  // restore white color
  document.getElementById('hide_option').style.display= 'block';
  document.getElementById('options').style.display= 'block';
  document.getElementById('start').classList.remove('center-xy');  // ex 'child' class    
  document.getElementById('start_div').style.display= 'none';    
  document.getElementById('show_option').style.display= 'none';  
  document.getElementById('hide_option').style= 'text-align:center';  // bug? auto-remove style when element.style.display="none"
  document.getElementById('instructions').style.display= 'none';     
  if (is_storage && localStorage.getItem('wm16-v1.0')) 
  {
    let cnt= JSON.parse(localStorage.getItem('wm16-v1.0')).length;                                                        
    document.getElementById('store_cnt').textContent=  'You have a total of ' + cnt  + ' wm16 results stored in your web browser.';
  }
  dirty= false;
  //document.getElementById('is_valid').textContent='';  // tmp reset validator message
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById('options').style.display = 'none'; 
  document.getElementById('start').classList.add('center-xy');   // ex 'child' class 
  document.getElementById('show_option').style.display = 'block';   
  document.getElementById('start_div').style.display = 'block';        //.removeAttribute("disabled");  
  document.getElementById('hide_option').style.display = 'none';   
  //document.getElementById('start_div').style= 'text-align:center';  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById('show_option').style= 'text-align:center';  
  document.getElementById('instructions').style.display= 'block';
  refMsg(); 
  setIns();	
}


// set instructions text depending on user selected task options
function setIns()  
{
  document.getElementById('instructions').style.display= 'block';		     
  if (isCross) {
    document.getElementById('ins_cross_on').style.display= 'block'; 
    document.getElementById('ins_cross_off').style.display= 'none'; 
  }
  else  {
    document.getElementById('ins_cross_on').style.display= 'none'; 
    document.getElementById('ins_cross_off').style.display= 'block'; 
  }  
  document.getElementById('ins_back').style.display= is_back ? 'block' : 'none';
	document.getElementById('ins_prg').style.display= (prg_type == '1') ? 'block' : 'none';
  document.getElementById('ins_demo').style.display= demo ? 'block' : 'none';	
}	

 
// refresh Options (update *_msg label) => give user short option HELP
function refOpt(e)  
{   
  dirty= true;       
  let my_id = e.id, msg = document.getElementById(my_id + '_msg'), s = 'Values within this range are allowed: ', s2= ' with step= ';               
	switch (my_id)
	{
		
		case 'lc':
		case 'hc':		
		case 'wc':
			if (e.validity.valid)  {           
				msg.removeAttribute('class');       
				msg.textContent= '';       //msg.textContent=  e.value; 
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');    // msg.className = 'error';
			} 
			checkItem();     
      break;
		
		case 'custom':
		  if (e.checked)  {
				msg.innerHTML=  "Yes. <b>You can't use Spatial if you use your Custom raster.</b>";
				document.getElementById('p_spatial').style.display= 'none';
				document.getElementById('p_raster').style.display= 'block';
        document.getElementById('lc').min= 1;
				document.getElementById('hc').min= 1;	
        document.getElementById('lc').max= 36;
				document.getElementById('hc').max= 36;
        document.getElementById('lc').step= 1;
				document.getElementById('hc').step= 1;
			}
			else  {				
				msg.innerHTML=  'No. Spatial is enabled.';
				document.getElementById('p_spatial').style.display= 'block';
				document.getElementById('p_raster').style.display= 'none';
        document.getElementById('lc').min= 2;
				document.getElementById('hc').min= 2;	  
				document.getElementById('lc').max= 16;
				document.getElementById('hc').max= 16;
        document.getElementById('lc').step= 2;
				document.getElementById('hc').step= 2;        
        if (!document.getElementById('lc').validity.valid) {
					document.getElementById('lc').value= 2;	
				}
				if (!document.getElementById('hc').validity.valid) {
					document.getElementById('hc').value= 2;	
				}
				if (!document.getElementById('wc').validity.valid) {
					document.getElementById('wc').value= 3;	
				}
			}
      checkItem(); 
			break;
		
		case 'raster':
			if (e.validity.valid)  {           
				msg.removeAttribute('class'); 
        let tmp= parseInt(e.value,10);				 				
				msg.textContent= 'If raster is higher, the screen will be broken down into a larger number of rectangles (parts) and task will be more difficult. Number of parts (rectangles, cells) on screen=' + (tmp * tmp);       
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');    // msg.className = 'error';
			} 		
			break;
		
		case 'spatial':		
			if (e.value == '0')  {
				msg.textContent= 'Circles will be randomly displayed'; 
				document.getElementById('spat_w').style.display= 'none';
        document.getElementById('lc').min= 1;
				document.getElementById('hc').min= 1;		
				document.getElementById('lc').step= 1;
				document.getElementById('hc').step= 1;				
        if (!document.getElementById('lc').validity.valid) {
					document.getElementById('lc').value= 1;	
				}
				if (!document.getElementById('hc').validity.valid) {
					document.getElementById('hc').value= 3;	
				}
				if (!document.getElementById('wc').validity.valid) {
					document.getElementById('wc').value= 1;	
				}				
			}
			else   
			{
				msg.textContent= (e.value == '1') ? '50% of circles will be in left part of screen. Other 50% will be in right part of screen' : '50% of circles will be in up part of screen. Other 50% will be in down part of screen';
				document.getElementById('spat_w').style.display= 'block';				
				document.getElementById('lc').min= 2;
				document.getElementById('hc').min= 2;		
				document.getElementById('lc').step= 2;
				document.getElementById('hc').step= 2;					
				if (!document.getElementById('lc').validity.valid) {
					document.getElementById('lc').value= 2;	
				}
				if (!document.getElementById('hc').validity.valid) {
					document.getElementById('hc').value= 2;	
				}
				if (!document.getElementById('wc').validity.valid) {
					document.getElementById('wc').value= 3;	
				}
			}
			checkItem(); 
			break;
			
		case 'wait':  
			if (e.validity.valid)  {
				msg.textContent=  'Time between stimuli. This is also time interval when it is possible to correct an previous task (if footer option Go back is enabled). Value= ' + e.value + ' ms'; 
				msg.removeAttribute('class');
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step; 
				msg.setAttribute('class', 'error');
			}          
			break;    
		
		case 'time': 
		case 'delay':	 
			if (e.validity.valid) {
				msg.textContent= 'Value= ' + e.value + ' ms'; 
				msg.removeAttribute('class');
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');
			} 
			break;    
				
		// case 'is_cross': => nop
		
		case 'is_grid':
		  msg.textContent= e.checked ? 'A rectangular grid will be displayed on the screen' : 'A rectangular grid will not be displayed on the screen'; 
			break;
			
		case 'is_white': 	
		  msg.textContent= e.value == '1' ? 'The fixation point (cross) is enabled in the delay period' : 'The fixation point (cross) is not enabled in the delay period';
      break;
      
    case 'demo': 
			msg.textContent= e.checked ? 'Demo mode is ON' : 'Demo mode is OFF';    
			break;
		
    case 'is_back':     		
			msg.textContent= e.checked ? 'Yes. You can correct your last answer before display next stimulus.' : 'No';    
			break;
    	
    case 'prg_type':
      msg.textContent= e.value == "1" ? 'It will be displayed how many items are left to the end.' : 'Nothing';       
      break;    
				 
		case 'store':                                                                                                                                            
			if (e.value === '1') {
        msg.textContent= 'This web application will store the results inside your web browser (no expiration date). Useful for group research';
        document.getElementById('store_info').style.display= 'block';
      }
      else  {
        msg.textContent= 'This web application will not store results within your web browser. Data is lost when the browser tab is closed';
        document.getElementById('store_info').style.display= 'none';
      }
			break;
 
	}   // switch
	
  refMsg();   
}


// check if items count is valid or not
// update item count on options form and check lc <= hc and update  label itemCnt = wc*(hc-lc+1);
function checkItem()  
{
  let _lc = document.getElementById('lc');
  let _hc = document.getElementById('hc');
  let _wc= document.getElementById('wc');
  let _item= document.getElementById('item_total');
  let lc_msg= document.getElementById('lc_msg');
  let hc_msg= document.getElementById('hc_msg');    
  if (_lc.validity.valid  && _hc.validity.valid && _wc.validity.valid)   
  {                      
    if  ( parseInt(_lc.value,10) > parseInt(_hc.value,10) )  
    {
      lc_msg.textContent= 'The starting level must not be higher than the final level';  
      hc_msg.textContent= 'The starting level must not be higher than the final level';
      lc_msg.setAttribute('class', 'error');
      hc_msg.setAttribute('class', 'error');    
      _item.textContent= 'Total number of items: Invalid value'; 
      _item.setAttribute('class', 'error');
    } 
    else   
    {                                                                                               
      lc_msg.removeAttribute('class');    //lc_msg.textContent= _lc.value;
      hc_msg.removeAttribute('class');   //hc_msg.textContent= _hc.value; 
      lc_msg.textContent= '';  
      hc_msg.textContent= '';
      let cnt= 0, level= parseInt(_lc.value,10);  // update cnt => total item count in task  
      while (level <=  parseInt(_hc.value,10))
      {
        cnt+= parseInt(_wc.value,10);    
        if (!custom && spatial != '0') {
          level+= 2;   // each second level is generated. see stimGenSpatial()	      
        }
        else {
          level++;  //  each level is generated. stimGenCustom()	and stimGen() functions 
        }
      } 
      _item.textContent=  'Total number of items: ' + cnt ;      
      _item.removeAttribute('class');
    }
  } 
  else  
  {
    _item.textContent= 'Total number of items: Invalid value'; 
    _item.setAttribute('class', 'error');
  }    
}


// refresh main validator message for user defined OPTIONS 
function refMsg()   
{ 	
	if ( optionsValid() )  {
    document.getElementById('is_valid').textContent=  (dirty===true) ? 'All your settings have been successfully updated' : '';  
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#000000'); 
  }
  else  {
    document.getElementById('is_valid').textContent='Some of your options are incorrectly set. They were not updated.';   // These settings are marked in red. 
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#ff0000;font-weight:bold'); 
  } 	
}


// check for validity.valid object in all input type="number". see: setPar() and autoCorrect()
function optionsValid()  
{ 
  let res=  document.getElementById('lc').validity.valid && document.getElementById('hc').validity.valid &&
    (parseInt(document.getElementById('lc').value,10) <= parseInt(document.getElementById('hc').value,10))  &&   
    document.getElementById('wc').validity.valid  &&  
		document.getElementById('raster').validity.valid && 
		document.getElementById('wait').validity.valid && 
    document.getElementById('time').validity.valid &&       
    document.getElementById('delay').validity.valid;	
  return res;              
}


// start task (research) 
function startTask(e)   
{     
  	
	setPar();
  
  if (custom)  {
		stimGenCustom();
	}
	else 
	{
		if (spatial == '0')  {
			stimGen();
		}
		else   {             // else if (spatial == '1' || spatial == '2') {
			stimGenSpatial();
		}
	}
			
	document.body.style.backgroundColor= '#fff';
	document.getElementById('result_wrapper').style.display= 'none';
  document.getElementById('end').style.display= 'none'; 
  document.getElementById('start').style.display= 'none';              
	document.getElementById('task_section').style.display= 'block'; 	
  // prepare footer section..
	document.getElementById('footer').style.display= 'none'; 						
	document.getElementById('nav_items').textContent= '';  // always reset items/total	
	if (document.getElementById('prg_type').value == '0')  {
	  document.getElementById('progress_holder').style.display= 'none'; 
	}	
	else  {
		document.getElementById('progress_holder').style.display= 'block';
    document.getElementById('progress').setAttribute('style', 'width:100%');		
	}	
	 
  document.getElementById('canvas').style.display= 'block';
	document.getElementById('m_canvas').style.display= 'none';		
	    
  item= 0;
  			
  setRects();
  
	is_task= true; 
	
	step=0;   // finally "activate" timer  
	      
}


// protection from infinitive loops (if I miss something)
function autoCorrect()  
{
	let is_spatial= ( !custom && spatial != '0' ) ? true: false; 
  
  if ( lc > hc )  {
		lc= hc;
	}
  if ( is_spatial )  {
     if (lc % 2 != 0) {
       lc= 2;  // autocorect Start level to even number. see stimGenSpatial() lc has always increament in loops +2
     }
     if (hc % 2 != 0)  {
       hc= 2;  
     }
  }
    
	if (custom)  {
	  if ( hc > 36 )  {
			hc= 36;
		}		
	}
	else   {
		raster= 10;
		if (lc > 16) {
			lc = 16;  
		}
		if (hc > 16) {
			hc = 16;  
		}					
	}
}


// set internal application research parameters (global vars)
function setPar()  
{  
  autoCorrect();

  correct= []; 
  answer= [];	
  moves= []; 	
	
  item_cnt= 0;   // compute total item count in task
  let level= lc;  // number of visible circles (dots)
  while (level <= hc)
  {
    item_cnt+= wc;    
    if (!custom && spatial != '0') {
      level+= 2;   // each second level is generated. see stimGenSpatial()	      
    }
    else {
      level++;  //  each level is generated. stimGenCustom()	and stimGen() functions 
    }
  }    
	
  let up= raster * raster;
  for (let i= 0; i< item_cnt; i++)   
  { // i => item
    correct[i]= [];
		answer[i]= [];	  
    moves[i]= 0;  // number of moves for each item in task
    for (let j= 0; j< up; j++)  {     
			correct[i][j]= 0;	
			answer[i][j]= 0;
    }
  } 
}


/* stimulus generator for custom raster (raster can be != 10). 
   used only if window.custom = true 
	 set initial circles position before and after delay */
function stimGenCustom()	
{
	// circles positions before delay => correct array
	// circles positions after delay => answer array
	
	// 1. set circles positions before delay => correct array
	const off = 3; // offset from screen center (rows and column count offset) 
	let pos, sel, row, col, ok;
	let vis= lc, cnt= 0, last= raster*raster-1, center= Math.floor(raster/2);
	if (hc % 2 != 0) {
		center-=1;
	} 
	for (let i= 0; i< item_cnt; i++)    // i => item  
	{	// set initial circles position before delay	
    sel={};  // already selected cells within current item			
		for (let k=0; k<vis; k++)				// vis => number of visible circles in current item
		{
			do  
			{	
				pos= getRndInt(0, last);
				row = Math.floor (pos / raster);
	      col = Math.floor (pos % raster);  // or => col= pos - row * raster;  // pos = row * raster + col; 			  
				ok = row < center - off || row > center + off || col < center - off || col > center + off ; 
			} while (!ok || typeof sel[pos] != 'undefined' );
			correct[i][pos]= 1;   // position of circle BEFORE delay			  
			sel[pos]= 1;  // remember this position (choice)
		}
		cnt++;
    if (cnt >= wc)  {
      cnt=0;
			vis++;
    }		 		
	}	
	
	// 2. set circles positions after delay => answer array 
	if (demo)  
	{  
		for (let i in correct)    
		{  // i => item
		  for (let j in correct[i])  {  // j= position of circle within each item
			  answer[i][j]= correct[i][j];  // if (demo) position of circle AFTER delay = position of circle BEFORE delay
			}		
		}
	}
	else	// set initial circles position AFTER delay. they are always different form initial positions
	{    // set answer != correct		
		vis= lc;
		cnt=0;
    let arr= [];	// arr => left and right bounds offset from screen center (for rows and columns)
		if ( hc <= 16 )  {
			arr= [center-2, center+1];  // 4 rows + columns range: center-2, center-1, center, center + 1 
		}
		else if ( hc <= 25 )  {  
			arr= [center-2, center+2];   // 5 rows + columns range: center-2, center-1, center, center + 1, center + 2 
		}
		else  {
			arr= [center-3, center+2];  // 6 rows + columns range: center-3, center-2, center-1, center, center + 1, center + 2
		}
		for (let i= 0; i< item_cnt; i++)    // i => item  
		{		
			sel={};  // already selected cells within current item	
			for (let k=0; k<vis; k++)				// vis => number of visible circles in current item
			{
				do  
				{	
					pos= getRndInt(0, last);
					row = Math.floor (pos / raster);
					col = Math.floor (pos % raster);  // or => col= pos - row * raster;  // pos = row * raster + col; 					
					ok = row >= arr[0] && row <= arr[1] && col >= arr[0] && col <= arr[1]; 
				} while ( !ok || typeof sel[pos] != 'undefined');
				answer[i][pos]= 1;  // position of circle AFTER delay
				sel[pos]= 1;  // remember this choice
			}
			cnt++;
			if (cnt >= wc)  {
				cnt=0;
				vis++;
			}		 		
		}			
	}	
}


// stimulus generator. set initial circles position before and after delay 
function stimGen()	
{
	// circles positions before delay => correct array
	// circles positions after delay => answer array
	
	// 1. set circles positions before delay => correct array
	let vis= lc, cnt=0, j, sel;	
	for (let i= 0; i< item_cnt; i++)    // i => item  
	{	// set initial circles position before delay	
    sel={};  // already selected cells within current item	
		for (let k=0; k<vis; k++)				// vis => number of visible circles in current item
		{
			do  {	
				j= rndArray(outer);
			} while ( typeof sel[j] != 'undefined');
			correct[i][j]= 1;   // position of circle BEFORE delay			  
			sel[j]= 1;  // remember this position (choice)
		}
		cnt++;
    if (cnt >= wc)  {
      cnt=0;
			vis++;
    }		 		
	}	
	
	// 2. set circles positions after delay => answer array 
	if (demo)  
	{  
		for (let i in correct)    
		{  // i => item
		  for (let j in correct[i])  {  // j= position of circle within each item
			  answer[i][j]= correct[i][j];  // if (demo) position of circle AFTER delay = position of circle BEFORE delay
			}		
		}
	}
	else	// set initial circles position AFTER delay. they are always different form initial positions
	{    // set answer != correct
		vis= lc;
		cnt=0;	
		for (let i= 0; i< item_cnt; i++)    // i => item  
		{		
			sel={};  // already selected cells within current item	
			for (let k=0; k<vis; k++)				// vis => number of visible circles in current item
			{
				do  
				{	
				  if (vis <= 4)  {						
						j= rndArray(inner4);
					}
					else if (vis <= 8)  {						
						j= rndArray(inner8);
					}
					else  {						
						j= rndArray(inner16);
					}
				} while ( typeof sel[j] != 'undefined');
				answer[i][j]= 1;  // position of circle AFTER delay
				sel[j]= 1;  // remember this choice
			}
			cnt++;
			if (cnt >= wc)  {
				cnt=0;
				vis++;
			}		 		
		}			
	}	
	
}


/* stimulus generator for spatial = 'Left-right' and spatial = 'Up-down'. 
   set initial circles position before and after delay 
	 within each item generate 50% of circles in left (up) half of screen 
	 within each item generate 50% of circles in right (down) half of screen */
function stimGenSpatial()	
{
	// circles positions before delay => correct array
	// circles positions after delay => answer array
	let hor= spatial == '1' ? true : false;  // hor == true => generate 50% left-50% right. hor == false => generate 50% up-50% down
			
	// 1. set circles positions before delay => correct array
	let vis= lc, cnt=0, j, sel;	
	for (let i= 0; i< item_cnt; i++)    // i => item  
	{	// set initial circles position before delay	
		sel={};  // already selected cells within current item			 
		for (let k = 1; k <= vis/2; k++)				// vis => number of visible circles in current item
		{  
			if (hor)
			{	// first 50% will be in left half  of screen
				do  {	
					j= rndArray(left);
				} while ( typeof sel[j] != 'undefined');
			}
			else 
			{  // first 50% will be in upper half  of screen
				do  {	
					j= getRndInt(0,29);   // xxx   positions up => 0..29.  first 3. rows  xxx
				} while (typeof sel[j] != 'undefined');	
			}
			correct[i][j]= 1;   // position of circle BEFORE delay			  
			sel[j]= 1;  // remember this position (choice)
		}		
		for (let k = vis/2 + 1; k <= vis; k++)				// vis => number of visible circles in current item
		{  
		  if (hor)
			{	// second 50% will be in right half of screen 
				do  {	
					j= rndArray(right);
				} while ( typeof sel[j] != 'undefined');
			}
			else
			{  // second 50% will be in down half of screen 
				do  {	
					j= getRndInt(70,99);  // xxx positions down => 70..99.  last 3 rows
				} while (typeof sel[j] != 'undefined');
			}			
			correct[i][j]= 1;   // position of circle BEFORE delay			  
			sel[j]= 1;  // remember this position 
		}		
		cnt++;
    if (cnt >= wc)  {
      cnt=0;
			vis+=2; // see this line.
    }		 		
	}	
	
	// 2. set circles positions after delay => answer array 
	if (demo)  
	{  
		for (let i in correct)    
		{  // i => item
		  for (let j in correct[i])  {  // j= position of circle within each item
			  answer[i][j]= correct[i][j];  // if (demo) position of circle AFTER delay = position of circle BEFORE delay
			}		
		}
	}
	else	// set initial circles position AFTER delay. they are always different form initial positions
	{    // set answer != correct
		vis= lc;
		cnt=0;	
		for (let i= 0; i< item_cnt; i++)    // i => item  
		{		
			sel={};  // already selected cells within current item	
      for (let k=0; k<vis; k++)				// vis => number of visible circles in current item
			{
				do  
				{	
				  if (vis <= 4)  {						
						j= rndArray(inner4);
					}
					else if (vis <= 8)  {						
						j= rndArray(inner8);
					}
					else  {						
						j= rndArray(inner16);
					}
				} while ( typeof sel[j] != 'undefined');
				answer[i][j]= 1;  // position of circle AFTER delay
				sel[j]= 1;  // remember this choice
			}
			cnt++;
			if (cnt >= wc)  {
				cnt=0;
				vis+=2; // see this line.
			}		 		
		}			
	}	

}


// return random item from 1-dim array. arr => 1-dim array
function rndArray(arr) {
  return arr[Math.floor(Math.random()*arr.length)];     
}


// Changes application settings that can be changed directly by the user within the options form
function setVarPar()  
{   
  	
	if (document.getElementById('lc').validity.valid && document.getElementById('hc').validity.valid 
    && (parseInt(document.getElementById('lc').value,10) <= parseInt(document.getElementById('hc').value, 10) ) )   {  
      lc= parseInt(document.getElementById('lc').value, 10); 
      hc= parseInt(document.getElementById('hc').value, 10); 
  }
  
  if (document.getElementById('wc').validity.valid) {
		wc= parseInt(document.getElementById('wc').value, 10); 
	} 
  
	custom= document.getElementById('custom').checked ? true: false;  
	
	if (custom && document.getElementById('raster').validity.valid)  {
		raster= parseInt(document.getElementById('raster').value, 10); 	
	}
	
	spatial= document.getElementById('spatial').value; 	
	
	if (document.getElementById('wait').validity.valid) {
		wait= Math.round(parseInt(document.getElementById('wait').value, 10)/clock);
  }
  
	if (document.getElementById('time').validity.valid) {
		time= Math.round(parseInt(document.getElementById('time').value, 10)/clock);  
  }
	
  if (document.getElementById('delay').validity.valid) {
		delay= Math.round(parseInt(document.getElementById('delay').value, 10)/clock); 
	}
	
	isCross= (document.getElementById('is_cross').value == '1') ? true: false;   
	
	is_grid= document.getElementById('is_grid').checked ? true: false; 
	
	is_white= (document.getElementById('is_white').value == '1') ? true: false; 
	
	demo= document.getElementById('demo').checked ? true: false; 
 						
	is_back= document.getElementById('is_back').checked ? true: false;        
  	
	prg_type= document.getElementById('prg_type').value;   
			     
  store= (is_storage && document.getElementById('store').value === '1') ? true : false;
  
}


// get random integer from min to max range
function getRndInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1)) + min;
}


// stop timer and draw second part previous stimulus again (this is now previous item)
function undoAnswer()  {     
  step = -1;         // stop timer (nop, idle, do none, Timer no operation)                  
  if (item > 0) { 
		item--;
  }	
  document.getElementById('prior').style.display= 'none';  // enable go back only for last item        
  drawStim(false);     // draw again second part of previous stimulus
}


// goto next item (stimulus)
function nextItem()  
{ 
  can_drag= false;  // disable drag and drop 
	clear(document.getElementById('canvas'));
	document.getElementById('m_canvas').style.display= 'none';
	
	item++;			
		
	if (item < item_cnt)  {         		 
     step= 0;     // "activate" Timer again        
  }
  else  {               
    step= -1 ; 
		theEnd();  // end of task if item >= item_cnt. Note: only this line code call theEnd()  
  }
}


/* draw (main) stimulus 
   if (first == true) => display first part of stimulus (stimulus before delay); 
   if (first == false) => display second part of stimulus (stimulus after delay);  */        
function drawStim(first) 
{    		
  let canvas= document.getElementById('canvas'), ctx= canvas.getContext('2d');	
	
	clear(canvas);
  
	if (is_grid) { 
    gridRect();	
  }		
   	  
  let dx = canvas.width / raster, dy = canvas.height / raster, row, col;
	let rad = Math.floor(Math.min(dx, dy)/2);  // this is circle (dot) radius. 
	 
	if (first)
	{
		if (isCross)  {
      drawCross();
    }
    ctx.fillStyle= '#000';
    for (let j in correct[item])
		{	    	     
			if (correct[item][j] == 1)
			{			 
				row = Math.floor (j / raster);
				col = Math.floor (j % raster);  // or => col= pos - row * raster;  // pos = row * raster + col;               						
				circle(ctx, col*dx+dx/2, row*dy+dy/2, rad, 0, 2*Math.PI, false); 				
			}		
		} 
		canvas.style.cursor= 'none';  // hide cursor after display first part of stimulus. see appTimer() step == 1
		document.getElementById('footer').style.display= 'none';	
	}
	else
	{
	  
    ctx.fillStyle= '#000';
    for (let j in answer[item])
		{	    	     
			if (answer[item][j] == 1)
			{			 
				row = Math.floor (j / raster);
				col = Math.floor (j % raster);  // or => col= pos - row * raster;  // pos = row * raster + col;               						
				circle(ctx, col*dx+dx/2, row*dy+dy/2, rad, 0, 2*Math.PI, false);   			
			}		
		}  
    canvas.style.cursor= 'auto'; // because of IE11  
    canvas.style.cursor= 'initial';  // restore cursor 
		can_drag= true;  // enable drag and drop 
    document.getElementById('next').style.display= 'inline';  // enable next item when complete stimulus is done
    document.getElementById('footer').style.display= 'block';
    updateFooter();		
	}
 	  
}


/* draw full circle or circle segment
  for parameters see: https://www.w3schools.com/tags/canvas_arc.asp  */  
function circle(ctx, x, y, r, sAngle, eAngle, clock)
{
  ctx.beginPath();   
  ctx.arc(x, y, r, sAngle, eAngle, clock);  //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);            
  //ctx.fillStyle= '#000';    // fill color   
  ctx.fill();  
}


// update footer when show main stimulus in task
// set footer 'next' item button (right arrow) and update progress bar
function updateFooter()
{  
	// note: footer 'prior' button is set in appTimer()	
	let btn= document.getElementById('next');     
	if (item == item_cnt-1)  {       
		btn.style.backgroundImage=  "url('img/end.png')";  // update 'Next item' image on 'right arrow' button 
		btn.title= 'End of task';
	}
	else  {
		btn.style.backgroundImage= "url('img/forward.png')"; 
		btn.title= 'Next task';
	}
	//btn.style.display= 'inline';  					
	if (prg_type == '1' )  {    // update Progress bar on footer => show current item count and remaining item count on Progress Bar (default)                                                                                                                                                       
		let percent = Math.round( 100 * (item+1) / item_cnt);      
		document.getElementById('progress').setAttribute('style', 'width:'+percent+'%');    // !important
		document.getElementById('nav_items').textContent= 'Item/Total= ' + (item + 1) + '/' + item_cnt  + '.   Percent= ' + percent.toFixed(2) + '%';  
	} 
}
	

// end of task (research)
function theEnd()  
{   

  is_task= false;    	
	
	document.getElementById('task_section').style.display= 'none';	
	document.getElementById('canvas').style.display= 'none';
	document.getElementById('m_canvas').style.display= 'none';  
	document.getElementById('footer').style.display= 'none';
  document.getElementById('end').style.display= 'block';   
  document.getElementById('result_wrapper').style.display= 'block'; 
	
	let is_spatial= ( !custom && spatial != '0' ) ? true: false; 
	let spat;  
  if (is_spatial)  {
		spat= getSpatialPoints();
	}

  let sum_points = 0, sum_moves= 0, mis= 0, max_score= 0, sum0= 0, sum1= 0, points = [], rows = [];    
	// compute points (and total score) for each item in task. 
	// for each item: if the circle was drag and drop in correct position user get 1 point. 
	let vis= getVisCount();  // vis => maximum possible score in each item in task
	for (let i=0; i<item_cnt; i++)  
	{
		points[i]= scoreItem(i);  // points for i-item 
		if (is_spatial)  {
			rows[i]= [ parseInt(i+1,10), points[i], vis[i], spat[i][0], spat[i][1], moves[i] ];  // => [ 'Item', 'Points' , 'Max-points', 'Points-left(up)', 'Points-right(down)', 'Moves' ]
		  sum0+=spat[i][0];  // sum left/up
			sum1+=spat[i][1];	 // sum right/down								
    }
		else  {
			rows[i]= [ parseInt(i+1,10), points[i], vis[i], moves[i] ];  // => [ 'Item', 'Points' , 'Max-points', 'Moves' ]        
		}
		// compute last rows => sums
		sum_points+= points[i];		// sum of all points during task 
    sum_moves+= moves[i];     // sum of all moves during task        
    if ( points[i] == 0 && moves[i] == 0 ) { 
			mis++;  // no action in this item => add missing value. this is sum of all missing values in task
    }			
		max_score+= vis[i];  // max_score => maximum possible score in task					
	}		
	document.getElementById('score').textContent= 'Sum of points= ' + sum_points + ' Maximum points= ' + max_score + ' Missing items= ' + mis; 
	   		
	if (is_spatial)  
	{
	  rows.push( [ 'Sum', sum_points, max_score, sum0, sum1, sum_moves] );	// add last summary row:	Sum for: Points, Max points, 'Points-left(up)', 'Points-right(down)', Moves 
		if (spatial == 1)  {
			createTableArray(document.getElementById('table1'), rows,  ['Item', 'Points', 'Maximum points', 'Points-left', 'Points-right', 'Moves']); 
		}
		else  {		
			createTableArray(document.getElementById('table1'), rows,  ['Item', 'Points', 'Maximum points', 'Points-up', 'Points-down', 'Moves']); 
		}	
	}
	else   {
		rows.push( [ 'Sum', sum_points, max_score, sum_moves] );	// add last summary row:	Sum for: Points, Max points, Moves
		createTableArray(document.getElementById('table1'), rows,  ['Item', 'Points', 'Maximum points', 'Moves']); 
	} 		
	document.getElementById('table1').style.display= 'block';  	
	
  // "chart" => for points - repaint "chart" 
  let percent= (100*sum_points/max_score).toFixed(2), not_done= (100-percent).toFixed(2);	
	document.getElementById('chart_title').textContent= 'Success percentage (green)= ' + percent + '% Failure Percentage (red)= ' + not_done + '%';
	document.getElementById('chart_cor').setAttribute('style', 'width:' + percent + '%');    // !important
	document.getElementById('chart_err').setAttribute('style', 'width:' + not_done + '%');

	if (is_spatial)  
  {
		document.getElementById('chart2_wrapper').style.display= 'block';
		let v0= (100*sum0/(max_score/2)).toFixed(2);	
	  document.getElementById('chart2a_title').textContent= (spatial == '1') ? 'Success percentage for Left = ' + v0 + '%'  : 'Success percentage for Up = ' + v0 + '%';
    document.getElementById('chart2a').setAttribute('style', 'width:' + v0 + '%');    // !important
		let v1= (100*sum1/(max_score/2)).toFixed(2);
    document.getElementById('chart2b_title').textContent= (spatial == '1') ? 'Success percentage for Right = ' + v1 + '%' : 'Success percentage for Down = ' + v1 + '%';
    document.getElementById('chart2b').setAttribute('style', 'width:' + v1 + '%');		
	}
	else  {
		document.getElementById('chart2_wrapper').style.display= 'none';		
	}
		
	try 
  {
    if (store) {
			setStorage(sum_points, max_score, mis, sum0, sum1); 
    }
  }        
  catch (e)  { 
    document.getElementById('table_grp').style.display= 'block';
		document.getElementById('table_grp').textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }    	 
	
}


// return array of points for each item by spatial positions. 
// 1. index is item number. second array index is: 0 == left(up) and 1 == right(down)  
function getSpatialPoints()
{
	let res= [];  // function result
	for (let i=0; i<item_cnt; i++)  {  // i == item
		res[i]= [];
		res[i][0]= 0;  // index 0 => left  (up)
		res[i][1]= 0;  // index 1 => right (down)
	}
	
	if (spatial == '1')			// left - right
	{	
		let o_left= {}, o_right= {}, key;  // for search by key in tmp objects
		for (let i in left)  {
			key= left[i];
			o_left[key]= key;		
		}
		for (let i in right)  {
			key= right[i];
			o_right[key]= key;		
		}				
		for (let i=0; i<item_cnt; i++)  
		{  // i == item 
		  for (let j in answer[i])  
			{	    // j == circle position 	     
				if (answer[i][j] == 1 && correct[i][j] == 1)
				{ 
					if ( typeof (o_left[j]) != 'undefined' )  {			 	
						res[i][0]++;
					}
					else if ( typeof (o_right[j]) != 'undefined' )  {			 	
						res[i][1]++;
					}
				}
			}		
		}	
	}
	else 			// up - down
	{			
		for (let i=0; i<item_cnt; i++)  
		{  	// i == item 
		  for (let j in answer[i])  
			{	    // j == circle position 	     
				if (answer[i][j] == 1 && correct[i][j] == 1)
				{ 
					if ( j < 30 )  {			 	
						res[i][0]++;      //    up => 0..29
					}
					else if ( j > 69 )  {			 	
						res[i][1]++;		// down => 70..99
					}
				}
			}		
		}	
	}
	return res;
}	


// Formats the date in the desired format. If you do not want this string format do not call this function. use: new Date()
function setDate()  
{
	let today = new Date();
	let dd = today.getDate();
	let mm = today.getMonth()+1; 
	let yyyy = today.getFullYear();
	//if(dd<10) { dd='0'+dd; } 
	if(mm<10) {	mm='0'+mm; } 
	today = dd+'.' + mm + '.' +yyyy;
	return today;
}


/* Store the results of the last completed task in the user's browser
   set user data into window.localStorage. Parameters:
	 score  => total number of points in task. user get 1 point for each ok drag and drop circles (in correct cell)
   max_score => maximum possible score in task
   mis => number of missing items (no moves and no point in this item)
   sum0 => points (score) for left (up) part of screen   
   sum1 => points (score) for right (down) part of screen  */ 
function setStorage(score, max_score, mis, sum0, sum1)   
{  
  let is_spatial= ( !custom && spatial != '0' ) ? true: false;
	let oldItems = JSON.parse(localStorage.getItem("wm16-v1.0")) || []; 
  let id= oldItems.length+1;     	
	// set new "record"
  let newItem = {
      'id' : id,
      'date' : setDate(),   //new Date(),  		   
      'score' : score, 	
			'max-score' : max_score,
      'missing': mis,
      'score-left-up'    : is_spatial ? sum0 : '', 
			'score-right-down' : is_spatial ? sum1 : '',             
    	'items' : item_cnt,  
			'demo' : demo ? 1 : 0,
			'start-level' : lc,
      'final-level' : hc,
      'within-level' : wc,			
			'custom-raster' : custom ? 1 : 0,
      'raster' : raster,
      'spatial' : custom ? '' : spatial, 		      
			'time-between' : wait * clock,        
      'time-display' : time * clock,
      'time-delay' : delay * clock,			
			'cross' : isCross ? 1 : 0,
      'grid' : is_grid ? 1 : 0,
			'delay-color': is_white ? 1 : 0,
		 	'is-back' : is_back ? 1 : 0,	
		  'dx' : Math.round(rects[0].w),
      'dy' : Math.round(rects[0].h)			
  };

  oldItems.push(newItem);

  localStorage.setItem("wm16-v1.0", JSON.stringify(oldItems));
  
	document.getElementById('table_grp').style.display= 'block';
  document.getElementById('store_id').style.display= 'block';
  document.getElementById('store_id').textContent= 'The results are stored in your browser. ID= ' + id ;
  
	createTableJSON(document.getElementById('table_grp'), oldItems); 
  
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  let col = [];
  for (let i = 0; i < my_json.length; i++) {
    for (let key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  let table = document.createElement("table");
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  let tr = table.insertRow(-1);                   // TABLE ROW.
  for (let i = 0; i < col.length; i++) {
      let th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (let i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (let j = 0; j < col.length; j++) {
      let tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


/* convert array data dynamically to HTML table - dynamically create html table
   elem == DOM html element (node)
   data => 1-dim or 2-dim array (matrix)
   col => string column descriptions. Set an empty string if you want to skip a column inside a 2-dim array	 */ 
function createTableArray(elem, data, col) 
{  
	let table= document.createElement("table");  // html table
  let tr= table.insertRow(-1), th, cell, tmp;  // table row, table header, table cell 	
  // create html table header row using the extracted headers above  
  for (let i in col) {
		if ( col[i] == '' ) { continue; } // set an empty string if you want to skip a column inside a 2-dim array
		th= document.createElement("th");      
		th.innerHTML = col[i];
		tr.appendChild(th);
  }
  if ( is2dArray(data) ) 
	{ // add 2-dim array data to the table as rows		
		tmp= data.length;
		for (let i = 0; i < tmp; i++) 
		{
			tr= table.insertRow(-1);
			for (let j in col) {
				if (col[j] == '') { continue; }  // set an empty string if you want to skip a column inside a 2-dim array
				cell= tr.insertCell(-1);
				cell.innerHTML = data[i][j];
			}
		}
  }
	else 
	{	// add 1-dim array data to the table as only one row
		tr= table.insertRow(-1);
		tmp=data.length;
		for (let i = 0; i < tmp; i++)	{
			cell= tr.insertCell(-1);
			cell.innerHTML = data[i];
		}
	}	
  elem.innerHTML= '';
  elem.appendChild(table); // finally add the newly created table with string data to a html container
}


// test if array is 2-dim (return true) or not (return false)
function is2dArray(arr)
{
	if(arr[0] === undefined){
		return false;
	}
	else	{
		return (arr[0].constructor === Array);
	}
}


// clear web browser storage data for this application
function clrStorage()  
{  
  let cnt= localStorage.getItem('wm16-v1.0')  ?  JSON.parse(localStorage.getItem('wm16-v1.0')).length : 0;                                                        
  if (cnt === 0)  {
    alert('You have no wm16 data to delete');
    return;
  }  
  if ( !window.confirm('You have a total of ' + cnt  + ' wm16 results stored in your web browser. Continue?') ) { 
   return;
 }                                             
 if (window.confirm('Delete total saved wm16 results:  '  + cnt + '. This action cannot be undone. Final confirmation?') ) 
 { 
   window.localStorage.removeItem('wm16-v1.0'); 
   document.getElementById('store_cnt').textContent= 'All data has been deleted. No data  ';
 }  
}


// clear the e = canvas object/element
function clear(e)  {	 
  let ctx= e.getContext('2d');
	ctx.clearRect(0, 0, e.clientWidth, e.clientHeight);
}	


// draws a raster of rectangles on canvases
function gridRect()
{
  let canvas= document.getElementById('canvas'), ctx= canvas.getContext('2d');
  let	w = canvas.width, h = canvas.height, dx = w / raster, dy = h / raster;
	//ctx.strokeStyle= '#000000'; ctx.lineWidth=1;	
	for (let row = 0; row <= raster; row++ )  
	{	    	
		for (let col = 0; col <= raster; col++)  
		{
			ctx.beginPath();
			ctx.rect(row*dx, col*dy, dx, dy);
			ctx.fillStyle= '#ffffff'; 
			ctx.fill();					
			ctx.stroke();
		}
	}	  
}


// creates array of (hidden) rectangles (cells) within an html canvas object
function setRects()
{
	let canvas= document.getElementById('canvas');
	let vis = (document.getElementById('footer').style.display == 'block') ? true: false; // currently footer is visible or not
	canvas.width= window.innerWidth;  
	canvas.style.width= canvas.width + 'px';	     
	document.getElementById('footer').style.display= 'block';  // tmp must be
	canvas.height= window.innerHeight - document.getElementById('footer').offsetHeight; // document.getElementById('footer').clientHeight == document.getElementById('footer').offsetHeight  
	canvas.style.height= canvas.height + 'px';  // https://css-tricks.com/whats-the-difference-between-width-height-in-css-and-width-height-html-attributes/ 
		
	let dx = canvas.width / raster, dy = canvas.height / raster;
	window.rects = []; 
	for (let row = 0; row < raster; row++ )
	{	    	
		for (let col = 0; col < raster; col++)
		{													
			let x = col * dx;
			let y = row * dy;  
			let	w = dx;
			let	h = dy;
			rects.push({
				x0:x,         
				y0:y, 
				w: dx,
				h: dy   
			});			     				
		}		
	}
  if (!vis) {
		document.getElementById('footer').style.display= 'none'; // hide again footer if footer was not visible	
	}
}


/* canvas => mousemove event	=> a pointing device is moved over an element (fired continuously as the mouse moves).
   this event is fired by html canvas element => document.getElementById('canvas') */
function showCanvas(e)
{  
  if (!can_drag) {
		return;
	}
	let canvas = document.getElementById('canvas'); // e.target || e.srcElement;     
  let m_canvas = document.getElementById('m_canvas');
   	
	let pos = getCellFromXY(e.offsetX, e.offsetY);
  
	if ( typeof(pos) === 'undefined'  )  {
    m_canvas.style.display= 'none';
		return;  
	}	
  else  {
		pos= parseInt(pos, 10);
	}	
  if ( answer[item][pos] != 1 )  {
    return; // abort all if circle is not visible in this rectangle (cell)
	}		
	
  let bounds= canvas.getBoundingClientRect();
  let offsetX = bounds.left, offsetY = bounds.top;	        
  let dx = canvas.width / raster, dy = canvas.height / raster; 
     
  // set absolute positions (left, top, width, height) for m_canvas object	
	let row = Math.floor (pos / raster);
	let col = Math.floor (pos % raster);  // or => col= pos - row * raster;  // pos = row * raster + col;               		
	m_canvas.style.left= parseInt(col*dx + offsetX, 10)  + 'px';  // top and left properties require a unit of measure, not just a number
  m_canvas.style.top= parseInt(row * dy + offsetY) + 'px';   
  /* the bottom 2 lines of code position the rectangle (left,top) exactly where the user clicked
  m_canvas.style.left= e.clientX + 'px';  // top and left properties require a unit of measure, not just a number
  m_canvas.style.top= e.clientY + 'px';  */ 
  m_canvas.width= dx;
  m_canvas.height= dy;    
  m_canvas.style.display= 'block';	
		
	m_canvas.setAttribute('data-pos', pos);   //  xxx  'data-pos' = cell position   xxx 
	
	//clear(m_canvas);  // clear content of m_canvas
	let ctx= m_canvas.getContext('2d');
	ctx.drawImage(canvas, col*dx, row * dy, dx, dy,  0, 0, dx, dy);  //void ctx.drawImage(image, sx, sy, sWidth, sHeight, dx, dy, dWidth, dHeight);
   		      
}


/* Get the cell (rectangle) ordinal position in html canvas element from x and y mouse position
   offsetX:  x - coordinate of the mouse pointer, relative to the target element. 
   offsetY:	 y - coordinate of the mouse pointer, relative to the target element. */
function getCellFromXY(offsetX, offsetY)
{	
  let canvas= document.getElementById('canvas');
	let dx =  canvas.width / raster, dy = canvas.height / raster;  
  let row = Math.floor ( offsetY / dy );  // The offsetX (offsetY) property returns the x (y) -coordinate of the mouse pointer, relative to the target element. 
  let col = Math.floor ( offsetX / dx );  // The clientX (clientY) property returns the horizontal (vertical) coordinate (according to the client area) of the mouse pointer when a mouse event was triggered.
  if (row > raster - 1 || row < 0 || col > raster - 1 || col < 0) {
    return;  // return 'undefined' value	=> abort all     
  }
  let pos = row * raster + col;   // rectangle position within html canvas object  	
	if ( pos >= raster * raster || pos < 0 ) {    
		return; // return 'undefined' value	=> abort all  
  }
	else {		
		return pos;	
	}
}	


// ondragstart event for html m_canvas object 
// html => <canvas id="m_canvas" draggable="true" ondragstart="dragStart(event)"></canvas>
function dragStart(e)  {   
  if (!can_drag) {
		return;
	}  
  //  xxxxx  'data-pos' = cell (rect) position   xxxxx 
	e.dataTransfer.setData('text', document.getElementById('m_canvas').getAttribute('data-pos') );	
}


// ondragover() event for html canvas element/object
// the ondragover event specifies wher the dragged data can be dropped
function allowDrop(e)  {
  e.preventDefault();
}


// ondrop() event for html canvas element/object
function drop(e)  
{  
  e.preventDefault();   
  let s_data= e.dataTransfer.getData('text');  //  data from start or SOURCE rect => source cell position 	
	let canvas = document.getElementById('canvas');  // ==  e.target || e.srcElement;       
  let d_data = getCellFromXY(e.offsetX, e.offsetY);   // destination cell position 	
  if ( typeof(s_data) === 'undefined' || typeof(d_data) === 'undefined' )  {
		return;  // abort all => source or destination rect data are missing
	}	 
	let s_pos= parseInt(s_data, 10), d_pos= parseInt(d_data, 10);   // pos = row * raster + col;
	let s_row = Math.floor (s_pos / raster), s_col = Math.floor (s_pos % raster);   // row, col, position within SOURCE rect               		
	let d_row = Math.floor (d_pos / raster), d_col = Math.floor (d_pos % raster);   // row, col, position within DESTINATION rect
					
  let m_canvas= document.getElementById('m_canvas');  
		
	clear(m_canvas);  // clear m_canvas content
	m_canvas.style.display= 'none';
	
  // update (swap) user answer => swap rectangles/cells positions
	let tmp= answer[item][s_pos];
	answer[item][s_pos]= answer[item][d_pos];
	answer[item][d_pos]= tmp;
  
  moves[item]++;
  drawStim(false);   // repaint stimulus again (update)
	
}


// return score for item i
// for each ok drag and drop circle position user get 1 point
function scoreItem(i)  
{
	let res= 0;
	for (let j in answer[i])  {	    	     
		if ( answer[i][j] == 1 && correct[i][j] == 1 )  {			 	
			res++;
		}
	}
	return res;
}


// return number of visible circles (dots) for all items 
// for each item in task => return number of visible circles (dots) in this item
function getVisCount()  
{
	let res= []; 
	for (let i in correct)   
  { 
    res[i]= 0;		
		for (let j in correct[i])  
		{	    	     
			if (correct[i][j] == 1)  {			 	
				res[i]++;
			}
		}
	}
	return res;
}
 